﻿using System;
using System.Collections.Generic;
using System.Data;
using System.IO;
using System.Xml.Serialization;

/// <summary>
/// XmlHelper 的摘要说明
/// </summary>
public class XmlHelper
{
    /// <summary> 

    /// 将XML转换为DATATABLE 

    /// </summary> 

    /// <param name="FileURL"></param> 

    /// <returns></returns> 

    public static DataTable XmlAnalysisArray(string filepath)
    {

        try
        {

            DataSet ds = new DataSet();

            ds.ReadXml(filepath);

            return ds.Tables[0];

        }

        catch (Exception ex)
        {

            System.Web.HttpContext.Current.Response.Write(ex.Message.ToString());

            return null;

        }

    }


    /// <summary> 

    /// 将DATASET 转换为 XML

    /// </summary> 

    /// <param name="FileURL"></param> 

    /// <returns></returns> 

    public static void DatasetConversionXML(DataSet ds, string FileURL)
    {

        try
        {
            ds.WriteXml(FileURL);

        }

        catch (Exception ex)
        {

            System.Web.HttpContext.Current.Response.Write(ex.Message.ToString());

        }


    }


    /// <summary>
    /// Xml序列化
    /// </summary>
    /// <typeparam name="T">对象的类型</typeparam>
    /// <param name="t">序列化对象实例</param>
    /// <param name="filePath">文件路径</param>
    public static void XmlSerializer<T>(List<T> t, string filePath)
    {
        XmlSerializer xmlSerializer = new XmlSerializer(typeof(List<T>));
        StreamWriter writer = new StreamWriter(filePath);
        //将s对象写入到指定的IO流文件中
        try
        {
            xmlSerializer.Serialize(writer, t);
        }
        catch (Exception)
        {

            //errr message
        }
        finally
        {
            writer.Close();
        }
    }

    /// <summary>
    /// Xml反序列化
    /// </summary>
    /// <typeparam name="T">对象类型</typeparam>
    /// <param name="t">对象实例</param>
    public static List<T> XmlDeserialize<T>(List<T> t, string filePath)  //必须是经过同样的过程反序列化好的文件
    {
        XmlSerializer mySerializer = new XmlSerializer(typeof(List<T>));
        FileStream myFileStream = null;
        if (File.Exists(filePath))  //检查文件是否存在
        {
            try
            {
                myFileStream = new FileStream(filePath, FileMode.Open);
                t = (List<T>)mySerializer.Deserialize(myFileStream);
            }
            catch (FileNotFoundException)
            {
                //File not Found
            }
            catch (Exception)
            {
                //the other error message
            }
            finally
            {
                myFileStream.Close();

            }
        }
        return t;
    }

}