﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Reflection;

public partial class FileToDB : System.Web.UI.Page
{
    //http://www.yongfa365.com/Item/SqlBulkCopy.html
    //http://www.cnblogs.com/scottckt/archive/2011/02/16/1955862.html 关于批量插入数据 
    protected void Page_Load(object sender, EventArgs e)
    {
        gdvEmployees.DataSource = GetEmployeeFromFile();
        gdvEmployees.DataBind();
    }

    private DataTable GetEmployeeFromFile()
    {
        return XmlHelper.XmlAnalysisArray(Server.MapPath(@"XML\Student"));
    }

    protected void btnDataToDB_ServerClick(object sender, EventArgs e)
    {
        bool isSuccessfully = SqlBulkCopy(GetEmployeeFromFile(), "Student");
        string str = isSuccessfully == true ? "成功" : "失败";
        ClientScript.RegisterStartupScript(this.GetType(), "mess", "alert('"+str+"')", true);
    }

    /// <summary>
    /// SqlBulkCopy批量添加
    /// 如何同时批量添加数据到两个表并且保持数据的一致性
    /// </summary>
    /// <param name="dt"></param>
    /// <param name="tableName"></param>
    /// <returns></returns>
    private bool SqlBulkCopy(DataTable dt, string tableName)
    {
        using (SqlBulkCopy sqlbulkcopy =
                           new SqlBulkCopy("server=.;database=Test1;uid=sa;pwd=sa", SqlBulkCopyOptions.UseInternalTransaction))
        {
            try
            {
                sqlbulkcopy.DestinationTableName = tableName;
                foreach (DataColumn c in dt.Columns)
                {
                    sqlbulkcopy.ColumnMappings.Add(c.ColumnName, c.ColumnName);
                }
                sqlbulkcopy.WriteToServer(dt);
                return true;
            }
            catch (System.Exception ex)
            {
                throw ex;
            }
        }
    }



    protected void btnTest_ServerClick(object sender, EventArgs e)
    {
        DataTable dt = DBHelper.ExecuteDataTable(CommandType.Text, "select * from Student", null); //XmlHelper.XmlAnalysisArray(Server.MapPath(@"XML\Student"));
        List<Student> tlist = dt.ToEntities<Student>();
        DataTable dt2 = tlist.ToDataTable();
        Response.Write(dt2.Rows.Count);
        //var dt = XmlHelper.XmlAnalysisArray(Server.MapPath(@"XML\Student"));
        //var ts = dt.ToEntities<Student>();
    }
}

public static class DataTableEntityInteroperate
{
    /// <summary>
    /// List<T> to DataTable
    /// </summary>
    /// <typeparam name="T">Entity</typeparam>
    /// <param name="entities">Entities</param>
    /// <returns>DataTable</returns>
    internal static DataTable ToDataTable<T>(this List<T> entities) where T : class,new()
    {
        //IsNull return
        if (null == entities || entities.Count == 0)
            return null;
        //Initial Columns
        DataTable dt = new DataTable();
        PropertyInfo[] pArray = typeof(T).GetProperties();
        try
        {
            Array.ForEach<PropertyInfo>(pArray, p =>
            {
                dt.Columns.Add(p.Name);
            });
            entities.ForEach(t =>
            {
                //Initial Rows
                DataRow dr = dt.NewRow();
                int i = 0;
                Array.ForEach<PropertyInfo>(pArray, p =>
                {
                    if (dt.Columns.Contains(p.Name))
                        dr[i] = p.GetValue(t); //Assigned to each column
                });
                i++;
                dt.Rows.Add(dr);
            });
            return dt;
        }
        catch (Exception)
        {

            throw;
        }

    }

    /// <summary>
    /// DataTable to Entities
    /// </summary>
    /// <typeparam name="T">Entity</typeparam>
    /// <param name="dt">DataTable</param>
    /// <returns>List<T</returns>
    internal static List<T> ToEntities<T>(this DataTable dt)/*必须来在于数据库来自于文件可能存在问题*/ where T : class,new()
    {
        //IsNullable
        if (null == dt || dt.Rows.Count == 0)
            return null;
        //Initial Entities
        List<T> entities = new List<T>();
        try
        {
            foreach (DataRow row in dt.Rows)
            {
                PropertyInfo[] pArray = typeof(T).GetProperties();
                T entity = new T();
                Array.ForEach<PropertyInfo>(pArray, p =>
                {
                    p.SetValue(entity, row[p.Name], null);
                });
                entities.Add(entity);
            }
            return entities;
        }
        catch (Exception)
        {
            throw;
        }
    }
}
public class Student
{
    public int StudentID { get; set; }
    public string Name { get; set; }
    public decimal Score { get; set; }
}